
// OMEGA NETWORK AS JAVA APPLET 

import awt.Image;
import awt.Graphics;
import browser.Applet;
import awt.Font;

class Rectan extends Applet{
int iput[]= new int[8];//Array that holds the selected i/p ports
int oput[]= new int[8];//Array that holds the selected o/p ports
int  stap[] = {18,68,118,168,48,98,148,198};
int o[] = new int[3];//Array that holds the bits of binary equiv of oput[]
int n,on;
int p1,p2,x1,x2;
 public void init()
	{ resize (600,600);
      n=0;
      on=0;
    for (int l=0;l<=7;l++)
    {
		iput[l] = -1;//initializing i/p ports to hold -1
		oput[l] = -1;//initializing o/p ports to hold -1
    }
    }
 public void start() {
	System.out.println("Rectan: start()");
					 }
 public void stop() {
	System.out.println("Rectan: stop()");
                    }
public void paint(Graphics g) {
int i,j;
int fr;
//initialize the check bit array to hold -1
int ck[]={-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1};
for (i=0;i<4;i++)
{	
/* 
Represents the connection between i/p ports and first stage switches
*/

    g.drawLine(90,2*i*25+18,140,stap[2*i]);
    g.drawLine(190,2*i*25+18,235,stap[2*i]);
    g.drawLine(90,(2*i)*25+48,140,stap[2*i+1]);
    g.drawLine(190,2*i*25+48,235,stap[2*i+1]);
    g.drawLine(300,2*i*25+18,345,stap[2*i]);
    g.drawLine(300,2*i*25+48,345,stap[2*i+1]);
	String name = Integer.toString(2*i,2);

/*
Ensure that all i/p and o/p ports are represented by  3 bits
by adding required number of 0 bits as prefix
*/

	if (name.length()==1)
	{
		name = "00"+name;
	}
	if (name.length()==2)
	{
		name = "0"+name;
	}
	String name1 = Integer.toString(2*i+1,2);
	if (name1.length()==1)
	{
		name1 = "00"+name1;
	}
	if (name1.length()==2)
	{
		name1 = "0"+name1;
	}
g.drawString("input",44,9);
g.drawString("output",433,9);

g.drawString (name,50,24+i*50);
g.drawString (name1,50,52+i*50);
g.drawString (name1,435,52+i*50);
g.drawString (name,435,24+i*50);
/*g.drawRect(30,15+i*50,35,35);
g.drawLine(15,18+i*50,30,20+i*50);
g.drawLine(15,48+i*50,30,50+i*50);
g.drawLine(65,18+i*50,80,18+i*50);
*/
g.drawLine(395,18+i*50,410,18+i*50);
g.drawLine(395,48+i*50,410,48+i*50);
/*g.drawLine(65,48+i*50,80,48+i*50);
g.drawLine(125,18+i*50,140,18+i*50);
g.drawLine(125,48+i*50,140,48+i*50);
*/
g.drawLine(175,18+i*50,190,18+i*50);
g.drawLine(175,48+i*50,190,48+i*50);
g.drawLine(285,18+i*50,300,18+i*50);
g.drawLine(285,48+i*50,300,48+i*50);
g.drawLine(235,18+i*50,250,18+i*50);
g.drawLine(235,48+i*50,250,48+i*50);
g.drawLine(345,18+i*50,360,18+i*50);
g.drawLine(345,48+i*50,360,48+i*50);
g.drawRect(140,15+i*50,35,35);//stage 0 switches
g.drawRect(250,15+i*50,35,35);//stage 1 switches
g.drawRect(360,15+i*50,35,35);//stage 2 switches
}
g.drawString("stage 0",135,10);
g.drawString("stage 1",245,10);
g.drawString("stage 2",355,10);
g.drawString("A",150,40);
g.drawString("B",150,90);
g.drawString("C",150,140);
g.drawString("D",150,190);
g.drawString("E",260,40);
g.drawString("F",260,90);
g.drawString("G",260,140);
g.drawString("H",260,190);
g.drawString("I",370,40);
g.drawString("J",370,90);
g.drawString("K",370,140);
g.drawString("L",370,190);
/*
Connections from i/p ports to o/p ports via the switching stages
checking for contentions at each stage
*/

for (int m=0;m <= 7; m++)
{
    int test=-1;
    String idata=Integer.toString(iput[m],2);
    g.drawString(idata,150,250+m*15);
    String odata=Integer.toString(oput[m],2);
    g.drawString(odata,220,250+m*15);
	if (iput[m] != -1 && oput[m] != -1)
	{
    int t=oput[m]/2;
/*
Extracting individual bits of the binary representation of o/p port
*/
 
    for (int k=0;k<3;k++)
	{
		o[k] = (oput[m]>>k)&0x1;
    //    g.drawString(Integer.toString(o[k],2),80,250+k*10);
	}

/* 
Stage 0 switch inter connection
*/
	if (iput[m] <= 3 && o[2]==1)
	{	
            if(ck[iput[m]]==3 || ck[iput[m]]==2){
            g.drawString("CONTENTION",30,400);
                               } 
            else{
			g.drawLine(140,18+iput[m]*50,175,48+iput[m]*50);
            if (ck[iput[m]]==-1) 
            {
            	ck[iput[m]]=1;
//				g.drawString(Integer.toString(ck[iput[m]]),30,400);
			}
            else
			{
				ck[iput[m]]=5;
//				g.drawString(Integer.toString(ck[iput[m]]),30,400);
             }
				}
    }
	if (iput[m] <= 3 && o[2]==0)
	{
            if (ck[iput[m]]==0 || ck[iput[m]]==1){
            g.drawString("CONTENTION",30,400);
		    					}		
            else{
			g.drawLine(140,18+iput[m]*50,175,18+iput[m]*50);
           	if (ck[iput[m]]==-1)
			{
				ck[iput[m]]=2;
//				g.drawString(Integer.toString(ck[iput[m]]),30,400);
			}
			else
			{
				ck[iput[m]]=4;
//				g.drawString(Integer.toString(ck[iput[m]]),30,400);
			}
				}
	}
	if (iput[m] >=4 && iput[m]<=7 && o[2]==1)
	{	
            if (ck[iput[m]-4]==1 || ck[iput[m]]==0){
            g.drawString("CONTENTION",30,400);
                                }
            else
            {
            g.drawLine(140,48+(iput[m]-4)*50,175,48+(iput[m]-4)*50);
            if (ck[iput[m]-4]==-1)
			{ 
				ck[iput[m]-4]=3;
//				g.drawString(Integer.toString(ck[iput[m]]),30,400);
			}
            else 
			{
				ck[iput[m]-4]=4;
//				g.drawString(Integer.toString(ck[iput[m]]),30,400);
			}
 			}
    }
	if (iput[m] >=4 && iput[m]<=7 && o[2]==0)
    {
            if (ck[iput[m]-4]==2 || ck[iput[m]-4]==3){
            g.drawString("CONTENTION",30,400);
                                }
            else
            {
			g.drawLine(140,48+(iput[m]-4)*50,175,18+(iput[m]-4)*50);
			if (ck[iput[m]-4]==-1)
			{
				ck[iput[m]-4]=0;
//				g.drawString(Integer.toString(ck[iput[m]]),30,400);
			}
			else 
			{
				ck[iput[m]-4]=5;
//				g.drawString(Integer.toString(ck[iput[m]]),30,400);
			}
			}
	}
	if (iput[m] -(iput[m]/2)*2 == 0)
	{	
/* 
Final stage switch interconnection
*/
	fr=18+(oput[m]-1)*25;
    if (o[0]==1)
    {
        if (ck[t+8]==2 || ck[t+8]==3){
            g.drawString("CONTENTION",350,400);
                                }
         else {
			g.drawLine(360,fr,395,fr+30);
            if (ck[t+8]==-1)
            { ck[t+8]=0;}
            else
            { ck[t+8]=5;}
			  }
    }
    else
	{
        if (ck[t+8]==0 || ck[t+8]==1)
        {g.drawString("CONTENTION",350,400);
                                }
        else{
		g.drawLine(360,18+oput[m]*25,395,18+oput[m]*25);
        if (ck[t+8]==-1)
        {ck[t+8]=2;}
        else
        {ck[t+8]=4;}
			}
	}
    }
	else
	{	
    fr=48+(oput[m]-1)*25;
    if (o[0]==1)
	{
        if (ck[t+8]==1 || ck[t+8]==0){
            g.drawString("CONTENTION",350,400);
                                }
        else{
		g.drawLine(360,fr,395,fr);
        if (ck[t+8]==-1)
		{ck[t+8]=3;}
        else
		{ck[t+8]=4;}
			}
    }
    else
    {
        if (ck[t+8]==2 || ck[t+8]==3)
        {g.drawString("CONTENTION",350,400);
                                }
        else {
		g.drawLine(360,48+(oput[m])*25,395,18+(oput[m])*25);
        if(ck[t+8]==-1)
        {ck[t+8]=0;}
        else
        {ck[t+8]=5;}
			}
	}
	}
    for (int c=0;c<=3;c++)
    {
/* 
Stage 1 switch inter connections 
*/
     if (iput[m] ==c || iput[m]==c+4)
     	{
			if(oput[m] <= 3)
            {p1=stap[2*c];
             x1=2*c; }
            else
            {p1=stap[2*c+1];
             x1 = 2*c+1;}
            if (o[1]==0 && c<=1 )
            {p2=p1;
             x2=x1;}
            if (o[1]==1 && c<=1)
            {p2=stap[x1+4];
             x2=x1+4;}
            if (o[1]==0 && c>=2 )
            {p2=stap[x1-4];
             x2=x1-4;}
            if (o[1]==1 && c>=2)
            {p2 = p1;
             x2=x1;}       
	}
    }
    if (x1<=3 && x1==x2)
    {
		if(ck[x1+4]==1 || ck[x1+4]==3)
		{ test=0;}
        else
        { test=1;
          if (ck[x1+4]==-1)
          { ck[x1+4]=0;}
          else
          { ck[x1+4]=4;}
             }
     }   
     if (x1<=3 && (x1-x2==-4))
     {
        if(ck[x1+4]==0 || ck[x1+4]==2)
        { test=0;}
        else
        { test=1;
          if (ck[x1+4]==-1)
          { ck[x1+4]=1;}
          else
          { ck[x1+4]=5;}
        }
      }
      if (x1>=4 && x2==x1)
      {
         if(ck[x1]==1 || ck[x1]==3)
         { test = 0;}
         else
         { test=1;
           if (ck[x1]==-1)
           { ck[x1]=2;}
           else
           { ck[x1]=4;}
         }
       }
       if (x1>=4 && x1-x2==4)
       {
         if(ck[x1]==0 || ck[x1]==2 )
         { test =0;}
         else
         { test = 1;
           if (ck[x1]==-1)
           { ck[x1]=3;}
           else
           { ck[x1]=5;}
          }
        }
           
	if(test==1){
    g.drawLine(250,p1,285,p2);
    }
    if(test==0){
    g.drawString("CONTENTION",225,400);
    }
    }
}
}

/*
Detecting the i/p ports and o/p ports selected by the user as mouse click
*/

public void mouseDown (int x, int y)
{
int i;
for (i=0;i<=3;i++)
{
if (x >=137 && x<=143  && y==(18+i*50) )
{
    for (int p=0;p<=7;p++)
    {
    if (y==stap[p])
    {
	iput[n] = p;
    n++;
    }
    }
	break;
}
if (x >=137 && x<=143 &&  y>=(45+i*50) && y<=(51+i*50))
{
    for (int p=0;p<=7;p++)
    {
    if (y>=(stap[p]-3) && y<=(stap[p]+3))
    {
	iput[n] = p;
    n++;
    }
    }
	break;
}
if (x>=392 && x<=398 && y>=(15+i*50) && y<=(21+i*50) )
{
    oput[on]=2*i;
    on++;
	break;
}
if (x>=392 && x<=398  && y>=(45+i*50) && y<=(51+i*50))
{
	oput[on] = 2*i+1;
    on++;
	break;
}
}
repaint();
}
}
