import java.io.InputStream ;
import awt.*;
import net.www.html.* ;
import browser.*;

import browser.Applet ;
import awt.Graphics ;



class Editor extends Applet {

   Image Impo,connect,graph;
   int X[],Y[];
   int flag = 1;
   int x1,y1,x2,y2;
   int draw_line = -1, drag_flag,connect_flag=0,graph_flag=0;
   int connect_color = -1;
   int M,N;
   int array_size =100;
   int no_of_block = 0;
   int RED=1,BLUE=2,GREEN=3,YELLOW=4 ;
   String status = " Welcome to WWVM editor" ;
   int moved_object;
   Frame thisframe;
   Window thiswin;
   hotjava thisjava;
   String helpString = new String("   Welcome to WebFlow Editor\n\nClick on Graph to enter into\nmodule placement placement mode. \nEach module has four ports. \n\nClick on Connect to enter into\nconnecting mode.By clicking over\nany port inside any  module you \nwill be connected to  all \nidentical port. Then you can choose \nports to form a channel between them\n");

/*************************   INIT  ***********************************/

       public void init()
        {
        int i;

         X = new int [array_size];
         Y = new int [array_size] ;

         x1=y1=0;
         x2=900;
         y2=600;

        for (i=0;i<array_size;i++)
          X[i]=Y[i]=5;

       Impo = getImage("images/editor.gif");
       connect = getImage("images/connect.gif");
       graph = getImage("images/graph.gif");

            resize(x2-x1,y2-y1);


 while((( thiswin = item.parent) == null) && (( item.getStatus() == AppletDisplayItem.STARTED) || ( item.getStatus() == AppletDisplayItem.INITIALIZING))) ;


        thisframe = thiswin.getFrame();
        thisjava =(hotjava) thisframe ;
        new displayW(thisframe.wServer,thisjava,helpString,"Help");

         }
/*************************   PAINT  ***********************************/

      public void paint(Graphics g)
        {
         int i=0;

         g.drawRect(x1,y1,x2-1,y2-1);
         g.drawImage(connect,x1+1,y2-60);
        g.drawImage(graph,x1+140,y2-60);
 
        showStatus(status);
   
/*
g.drawImage(Impo,1,1);
g.drawRect(1,1,105,80);
*/

      if (graph_flag == 1 )
       for(i=0;i < no_of_block  ; i++)
          g.drawImage(Impo,X[i],Y[i]);

/*
       if (drag_flag == 1)
          g.drawImage(Impo,M,N);
*/

       if(draw_line != -1)
          {
           connect_graph(g,draw_line);
           draw_line = -1;
           }
        }

/*************************   UPDATE  ***********************************/
      public void update (Graphics g)
         {
            drag_flag = 0;
            {
             g.clipRect(x1,y1,x2-1,y2-1);
             paint(g);
            }
          }

/************************* MOUSE-DRAG  ***********************************/
     public void mouseDrag(int x, int y)
       {

      if ( x < x2-20)
      {
         if( y < y2-20)
          {
             M =x;
             N = y;
         if( drag_flag == 0)
           {
             moved_object = inside_graph(x,y) ;
             drag_flag =1;
            }
          status = " Mouse was dragged " ;
          repaint();
          }
         else
          status = " You are out of Y limit" ;
       } 
       else
       status = " You are out of X limit " ;

        }
/************************* MOUSE-UP  ***********************************/
     public void mouseUp(int x, int y)
       {
    if(graph_flag ==1 && graph_valid(x,y) ==-1)  
      {

    if (drag_flag == 1)
       { 
       if(moved_object > -1)
        {
          X[moved_object] = x;
          Y[moved_object] = y;
         repaint();
         }
        }
      else
     { 
      X[no_of_block] = x;
      Y[no_of_block++] = y;
      status = " Plotted the Graph at X:= " + String.valueOf(x) + " Y :=" + String.valueOf(y); 
      repaint();
      }
    drag_flag = 0;
    return;
   }

 drag_flag = 0;
 moved_object = -1;
       

        if ( x < 140 && y > y2-60)
           {
            connect_flag = 1;
            graph_flag = 0;
             status = " You pressed Connect Button " ;
            repaint();
            return;
           }

       if ( x > 140 && x < 260 && y > y2-60)
           {
           graph_flag = 1;
           connect_flag = 0;
           status = " You pressed Graph Button ";
            repaint();
           return ;
          }



      if (connect_flag == 1)
          {
          draw_line = connect_valid(x,y);
       if  (draw_line > -1) 
          {
           repaint();
           return ;
          }
         }
   return ; 
          
       }

/******************** Connect_graph *****************************************/


      public void connect_graph(Graphics g, int b)
      {
       int i;
       int xdiff=0,ydiff=0;


       if(connect_color == RED)
         {
           g.setForeground(Color.red);
           xdiff = 30;
           ydiff = 10;
           status = " Connected Graph with Red Color ";
           repaint();
          }
       if(connect_color == BLUE)
        {
         g.setForeground(Color.blue);
          xdiff = 70;
          ydiff = 10;
           status = " Connected Graph with Blue Color ";
           repaint();
        }
       if(connect_color == GREEN)
         {
         g.setForeground(Color.green);
         xdiff = 30;
         ydiff = 60;
           status = " Connected Graph with Green Color ";
           repaint();
         }
       if(connect_color == YELLOW)
        {
       g.setForeground(Color.yellow);
          xdiff = 70;
           ydiff = 60;
           status = " Connected Graph with Yellow Color ";
           repaint();
         }

      for(i=0;i<no_of_block;i++)
       if(i != b)
        {
         g.drawLine(X[b]+xdiff,Y[b]+ydiff,X[i]+xdiff,Y[i]+ydiff);
        }
      }

/***************************** Connect_valid  *******************************/

     public int connect_valid(int x,int y)
        {
        int i;


       for(i=0;i<no_of_block;i++)
        {
         if ( x > X[i] +20 && x < X[i] + 40)
          if (y > Y[i] +0 && y < Y[i] +20)
           {
            connect_color = RED;
            return i;
           }

         if ( x  >X[i] +  60 && x < X[i] + 80)
          if (y > Y[i] +0 && y <Y[i] + 20)
           {
            connect_color = BLUE;
            return i;
           }

         if ( x  >X[i] +  20 && x < X[i] + 40)
          if (y >Y[i] + 60 && y <Y[i] + 80)
           {
            connect_color = GREEN;
            return i;
           }

         if ( x  > X[i] + 60 && x < X[i] + 80)
          if (y > Y[i] +60 && y < Y[i] +80)
           {
            connect_color = YELLOW;
            return i;
           }
       }
            
        
       return -1;

         }
/****************************** Graph_valid *****************************/


   public int graph_valid(int x, int y)
      {

  int i;

 for ( i = 0; i < no_of_block ; i++)
     {
          if(x < X[i] && x + 100 > X[i] ) 
            if ( y > Y[i] -80 && y < Y[i] +80)
            {
            status = "You are trying to over-write " ;
             repaint();
              return i; 
            }
         if( x > X[i] && x < X[i] +100)
            if ( y > Y[i] -80 && y < Y[i] +80)
          {
            status = "You are trying to over-write " ;
            repaint();
              return i;
           }
      }
    return -1; 
 }
 public int inside_graph(int x, int y)
  {
    int i;

  for (i=0;i< no_of_block; i++ )
   if ( x > X[i] && x < X[i] + 100)
     if( y > Y[i] && y < Y[i] + 80)
       return i;

  return -1;
 }
     
 
     
}

class displayW
 {
 Window mainWindow;
 Frame newframe;
 TextArea t;
 int noOfFile  = 4;

   public displayW(WServer serv,hotjava thisjava, String sDir,String titl)
    {
      int i;
      String s = new String();

         s =  sDir ;
//	s.trim();

   newframe = new Frame(serv,true,null,330,270,Color.lightGray);
   newframe.setTitle(titl);

  mainWindow = new Window( newframe,"Center",Color.lightGray,100,70);


 Font  defaultFont = serv.fonts.getFont("Courier",Font.PLAIN,14);
 t = new TextArea(mainWindow,"Center",defaultFont,100,15);
 t.setText(s);
 t.setEditable(false);
 t.setHFill(true);

/*
  new  quitButton(mainWindow,this);
*/

 newframe.map();
 }
}

