import browser.Applet;
import awt.Color;
import awt.Font;
import awt.Graphics;

class HelloWorld_9 extends Applet		{
	String fontType = "Helvetica", fontStyle = "BOLD", fontColor = "blue",
		fontSize = "36";
	int fontStyleValue = Font.BOLD, fontSizeValue = 36;
	Color upColorValue, downColorValue, textColorValue;
	Color outColorValue, inColorValue, appColorValue;
	Font helloFont;
	String mState;
	int mX, mY;
	int orX, nrX, orY, nrY, rW, rH;
	boolean fullPaint, dragMode;

	public void init()		{
		resize(600,400);
		helloFont = getFont(fontType,fontStyleValue,fontSizeValue);
		font = helloFont;
		outColorValue = getColor(200,200,200);
		inColorValue = getColor(220,220,220);
		appColorValue = outColorValue;
		upColorValue = Color.blue;
		downColorValue = Color.red;
		textColorValue = upColorValue;
		orX = nrX = 200;
		orY = nrY = 210;
		rH = fontSizeValue;
		fullPaint = true;
		dragMode = false;
					}
	public void paint(Graphics g)	{
		String str = "Hello World!";

		g.setForeground(appColorValue);
		g.paint3DRect(0,0,600,400,true,true);
		g.clipRect(0,0,600,400);
		g.setForeground(textColorValue);
		rW = g.drawStringWidth(str,nrX,nrY+rH);
		orX = nrX; orY = nrY;
					}

	public void update(Graphics g)	{
		if(fullPaint)	{
			paint(g);
			fullPaint = false;
				}
		else 		{
			g.clipRect(orX,orY,rW+2,rH+2);
			paint(g);
			g.clipRect(nrX,nrY,rW+2,rH+2);
			paint(g);
				}
					}

	protected void start()		{
		fullPaint = true;
		mState = "OUT";
		showStatus("START");
					}
	protected void stop()		{
					}

	public void mouseEnter()	{
		appColorValue = inColorValue;
		mState = "IN";
		fullPaint = true;
		repaint();
					}

	public void mouseExit()		{
		mState = "OUT";
		showStatus("Mouse= "+mState);
		appColorValue = outColorValue;
		fullPaint = true;
		repaint();
					}

	public void mouseUp(int x, int y)	{
		mState = "UP";
		mX = x; mY = y;
		showMouseStatus(x,y);
		textColorValue = upColorValue;
		if(dragMode) 	{ 
			textColorValue = upColorValue;
			dragMode = false;
				}
		else { nrX = x; nrY = y - rH; }
		repaint();
						}

	public void mouseDown(int x, int y)	{
		mState = "DOWN";
		mX = x; mY = y;
		showMouseStatus(x,y);
		if((x < orX)||(x >= (orX+rW))) return;
		if((y < orY)||(y >= (orY+rH))) return;
		textColorValue = downColorValue;
		if(dragMode) return; else { repaint(); dragMode = true; }
						}

	public void mouseDrag(int x, int y)	{
		mState = "DRAG";
		mX = x; mY = y;
		showMouseStatus(x,y);
		nrX = x; nrY = y - rH;
		if(dragMode) repaint();
						}

	public void mouseMove(int x, int y)	{
		mState = "MOVE";
		mX = x; mY = y;
		showMouseStatus(x,y);
						}

	public void showMouseStatus(int x, int y)	{
		showStatus("Mouse= "+mState+" X= "+String.valueOf(x)+
			" Y= "+String.valueOf(y));
							}

  
						}
  
