/*----------------------------------------------------------------------*/
/* DancingTitle puts annimated text in boxes - it is simply an interface to the 
       class Banner 
   *** DancingTitle and Banner together are an extension of DancingText which 
       was written by James Gosling at SUN
                                                                        */
/*----------------------------------------------------------------------*/
/*               Jim Morey  -  morey@math.ubc.ca  - Aug 20              */
/*----------------------------------------------------------------------*/
  
import java.io.InputStream;
import awt.*;
import browser.*;
import browser.audio.AudioData;
import net.www.html.*;

/*----------------------------------------------------------------------*/

public
class DancingTitle extends Applet implements Runnable {
  private Thread kicker = null;
  private int W,H;
  private boolean banner_ready=false;
  private Banner theBanner;
  private Float crap;

  /* -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  - */
  public void init() {
    /* .. I hope to have this up to date with Banner so that html files
         can do all the tricks Banner can .. */
    String s = null;

    W = Integer.parseInt(getAttribute("time"));
    try {
      W = Integer.parseInt(getAttribute("width"));
    } catch(Exception e) { W = 100; }
    try {
      H = Integer.parseInt(getAttribute("height"));
    } catch(Exception e) { H = 100; }

   W = W -200;
    resize(W,H);

    theBanner = new Banner(this,W,H);
    try {
      s = getAttribute("text");
    } catch(Exception e) { }
    try {
      theBanner.style = Integer.parseInt(getAttribute("style"));
    } catch(Exception e) { theBanner.style = 0; }
    try { 
      theBanner.audioName = getAttribute("sound"); 
      /* .. commented out in Banner .. */
    } catch(Exception e) { }
    try { 
      String junk = getAttribute("format"); 
      if (junk.indexOf("centre")!=-1) theBanner.centre = true;
      if (junk.indexOf("box")!=-1) theBanner.box = true;
    } catch(Exception e) { }
    theBanner.fontName = getAttribute("font");

    String colour = getAttribute("colour");
    if (colour != null){
      if (colour.equals("white")) theBanner.foreground = awt.Color.white;
      else if (colour.equals("red")) theBanner.foreground = awt.Color.red;
      else if (colour.equals("green")) theBanner.foreground = awt.Color.green;
      else if (colour.equals("blue")) theBanner.foreground = awt.Color.blue;
      else if (colour.equals("yellow")) theBanner.foreground = awt.Color.yellow;
    }
    else theBanner.foreground = awt.Color.yellow;

    try {
      theBanner.delay = Integer.parseInt(getAttribute("delay"));
    } catch(Exception e) { theBanner.delay = 50; }

    try {
      theBanner.amplitude = Integer.parseInt(getAttribute("wave"));
    } catch(Exception e) { theBanner.amplitude = 0; }
    try {
      crap = Float.valueOf(getAttribute("length"));
      theBanner.length = crap.floatValue();
    } catch(Exception e) { theBanner.length = 15.0; }
    try {
      theBanner.trans = Integer.parseInt(getAttribute("trans"));
    } catch(Exception e) { theBanner.trans = 0; }

    try {
      theBanner.pause = Integer.parseInt(getAttribute("pause"));
    } catch(Exception e) { theBanner.pause = 0; }

    try {
      theBanner.xborder = Integer.parseInt(getAttribute("xborder"));
    } catch(Exception e) { theBanner.xborder = 0; }
    try {
      theBanner.yborder = Integer.parseInt(getAttribute("yborder"));
    } catch(Exception e) { theBanner.yborder = 0; }

    try {
      theBanner.time = Integer.parseInt(getAttribute("time"));
    } catch(Exception e) { theBanner.time = 0; }

    theBanner.setup_words(s);

    kicker = new Thread(this);
    kicker.start();
  }    

  /* -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  - */
  public void run() {
    Thread.currentThread().setPriority(Thread.MIN_PRIORITY);

    /* .. get a blank window to draw the text .. */
    new Thread(theBanner).start();
    banner_ready = true;
  }

  /* -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  - */
  public void paint(Graphics g) {
    update(g);
  }
  public void update(Graphics g) {
    if (banner_ready) theBanner.paint(g);
  }

  /* -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  - */
  public void mouseDown(int x, int y) {
    theBanner.style = theBanner.style +1;
    if (theBanner.style == 8) theBanner.style = 0;
    new Thread(theBanner).start();
  }

}







