import browser.Applet;
import net.*;
import awt.*;

class TCE extends Applet	{
	Frame fr;
	WServer ws;
	int ixScan = 0, iyScan = 0;
	byte jScan = 1;
   boolean fullPaint = true;
   int x, y, xy;
   int dx, dy;
   int w,h;
   int rx0,ry0,rx1,ry1;
   byte vec[];
   Color pal[] = { Color.red, Color.green, Color.blue, Color.white,
		    Color.black, Color.magenta, Color.cyan, Color.yellow };
   
   public void init()	{
	fr = item.parent.getFrame();
	ws = fr.wServer;
	dx = 16; dy = 16;
	x = 64; y = 32;
	xy = x*y;
	w = x*dx; h = y*dy;
	vec = new byte[xy];
	resize(w,h);
//setRandom();
	repaint();
   }

   public void paint(Graphics g) {
	int ix,iy,j;
		for(iy=0; iy <y; iy++)	{
			for(ix=0; ix<x; ix++)	{
				j = iy*x + ix;
				g.setForeground(pal[vec[j]]);
				rx1=ix*dx; ry1=iy*dy;
				g.fillRect(rx1,ry1,dx,dy);
			}
		}
   }

   public void update(Graphics g) {
	g.clipRect(0,0,w,h);
	paint(g);
   }

   protected void start() {
	fullPaint = false;
	int n = 20;
	for(;;) {
		setRandom();
		repaint();
	}
   }

   protected void stop() {
   }

   public void setRandom() {
        int i;
        for(i=0; i<xy; i++)     {
                vec[i] = (byte)(8*Math.random());
        }
   }

   public void randomUpdate() {
	int ix = (int)(x*Math.random());
	int iy = (int)(y*Math.random());
	rx0 = ix*dx; ry0 = iy*dy;
	int j = iy*x + ix;
	vec[j] = 1;
   }
   public void scanlineUpdate() {
	ixScan++;
	if(ixScan >= x) { iyScan++; ixScan = 0; }
	if(iyScan >= y) { iyScan = 0; jScan++; if(jScan >7) { jScan = 0; } }
	rx0 = ixScan*dx; ry0 = iyScan*dy;
	int j = iyScan*x + ixScan;
	vec[j] = jScan;
   }
   public void setConst() {
	int i;
	for(i=0; i<xy; i++) {
		vec[i] = 2;
	}
   }
}
