/*  Daniel Wyszynski 
    Center for Applied Large-Scale Computing (CALC) 
    04-12-95 

    Test of text animation.

        Changes by kwalrath@scndprsn.Eng.Sun.COM : Added thread
        suspension.  Click on the text and it will pause.  Thanks
        Kathy.

*/
import awt.Graphics;
import awt.Font;
import awt.Color;
import java.util.Vector;
import browser.Applet;

class Renkler extends Object  {
        String key;
        Color value;

        Renkler() {}

        Renkler(String _key, Color _value)    {
                key = _key;
                value = _value;
                                                }
                                }

class HayvanYazisi extends Applet implements Runnable {

	Vector citv = new Vector();
        char separated[];
        String s = null;
        Thread killme = null;
        int i;
        int x_coord = 0, y_coord = 0;
        String num;
        int speed=35;
        int counter =0;
        boolean threadSuspended = false; //added by kwalrath

public void init() {
        resize(600,100);
        Font f = getFont("Helvetica",Font.BOLD,36);
        font = f;
	s = "A n i m a l s ";

        citv.addElement(new Renkler("black",Color.black));
        citv.addElement(new Renkler("blue",Color.blue));
        citv.addElement(new Renkler("cyan",Color.cyan));
        citv.addElement(new Renkler("darkGray",Color.darkGray));
//      citv.addElement(new Renkler("editableText",Color.editableText));
        citv.addElement(new Renkler("gray",Color.gray));
        citv.addElement(new Renkler("green",Color.green));
        citv.addElement(new Renkler("magenta",Color.magenta));
        citv.addElement(new Renkler("menuBack",Color.menuBack));
        citv.addElement(new Renkler("menuBright",Color.menuBright));
        citv.addElement(new Renkler("menuDim",Color.menuDim));
        citv.addElement(new Renkler("menuFore",Color.menuFore));
        citv.addElement(new Renkler("menuHighlight",Color.menuHighlight));
        citv.addElement(new Renkler("orange",Color.orange));
        citv.addElement(new Renkler("pink",Color.pink));
//      citv.addElement(new Renkler("readOnlyText",Color.readOnlyText));
        citv.addElement(new Renkler("red",Color.red));
        citv.addElement(new Renkler("white",Color.white));
        citv.addElement(new Renkler("yellow",Color.yellow));
 

        separated =  new char [s.length()];
        s.getChars(0,s.length(),separated,0);
 }

public void start() {
        if(killme == null) 
        {
        killme = new Thread(this);
        killme.start();
        }
 }

public void stop() {
        killme = null;
 }

public void run() {
        while (killme != null) {
        Thread.sleep(100);
        repaint();
        }
        killme = null;
 }

public void paint(Graphics g) {
	int off;
        for(i=0;i<s.length();i++)
        {
        x_coord = (int) (Math.random()*10+15*i);
        y_coord = (int) (Math.random()*10+36);
	off = (int)(Math.random()*citv.size());
	Renkler cit = (Renkler)citv.elementAt(off);
	Color col = cit.value;
	g.setForeground(col);
        g.drawChars(separated, i,1,x_coord,y_coord);
        }
 }

/* Added by kwalrath. */
public void mouseDown(int x, int y) {
        if (threadSuspended) {
            killme.resume();
        }
        else {
            killme.suspend();
        }
        threadSuspended = !threadSuspended;
    }
}

