
//import neuralnet.*;
import browser.*;
import java.lang.* ;
import java.io.* ;
import net.www.html.* ;
import awt.*;
//import net.Socket;
//import net.InetAddress;
import net.*;
import browser.Applet ;
import awt.Graphics ;
import awt.Color ;

class BackProp extends Applet {

	int  x1=200,x2=400,y1=0,y2=200,x,y;
        int  _32x1=100,_32x2=_32x1+320,_32y1=y2+30,_32y2=_32y1+320;;
	int cell[][];
	int drawcell[][];
	String netResult[];
        String docRoot = "/hpdc4/java/public_html/backprop/classes/";
	int ux,uy;
        int width,height; 
        controlPanel cp;
	Frame thisframe;
	Window thiswin;
	hotjava thisjava;
	String status = new String("Back Propagation");
	int mousedragflag=0,mouseupflag=0,repaintflag=1;
	int showNetflag =0;
        boolean atleastOnce;

	int nlayer;
	int momentumRate=0,learningRate=0;


	/*************************   INIT  ***********************************/

	public void init()
	    {  
		cell = new int [64][64];
		drawcell = new int [64][64];
		netResult = new String [30];
                atleastOnce = false;

		while((( thiswin = item.parent) == null) && 
		    (( item.getStatus() == AppletDisplayItem.STARTED) || 
		    ( item.getStatus() == AppletDisplayItem.INITIALIZING))) ;

		thisframe = thiswin.getFrame();
		thisjava =(hotjava) thisframe ;

                width =1000;  
                height = 1000;
		resize(width,height);
		repaint();
	        cp = new controlPanel(thisframe.wServer,thisjava,this);
		repaint();

	}
	/*************************   PAINT  ***********************************/

	public void paint(Graphics g)
	    {
		int  x,y;
		int i,j,h,w=15;
		int tx,ty;
		Float f;
		float max =-1,scaleFactor;
		int  s;
		String alphaStr[] = {
			"A","B","C","D","E","F","G","H","I","J","K","L","M","N","O","P","Q","R","S","T","U","V","W","X","Y", "Z"
		};
                if(atleastOnce==true)
		{
			for(i=0;i<26;i++)
			{
				f = Float.valueOf(netResult[i]);
				if( max < f.floatValue())
					max = f.floatValue();
			}

			scaleFactor = (float)(150/max);
			i =0;
			for(char c='A';c-1<'Z';c++,i++)
			{
				float temp;
				f = Float.valueOf(netResult[i]);
				temp = f.floatValue() *scaleFactor;
				h = (int) temp + 1;
				g.paint3DRect(i*w+100 ,y2+260 -h,w,h,true,true);
				g.drawString(alphaStr[i],i*w+102,y2+270);
                             if(f.intValue() !=0)
			//	g.drawString(String.valueOf((int)(f.intValue()/1.5)),i*w+102,y2+560-h-2);
				g.drawString(String.valueOf((int)(temp/1.5)),i*w+102,y2+260-h-2);
			}
		}


		for(x=x1;x<=x2;x+=25)
			g.drawLine(x,y1,x,y2);

		for(y=y1;y<=y2;y+=25)
			g.drawLine(x1,y,x2,y);



/*
		for(x=_32x1;x<=_32x2;x+=10)
			g.drawLine(x,_32y1,x,_32y2);

		for(y=_32y1;y<=_32y2;y+=10)
			g.drawLine(_32x1,y,_32x2,y);
*/
               

		//       g.setColor(Color.black);
		for(tx=x1,i=0;tx<=x2;tx+=25,i++)
			for(ty=y1,j=0;ty<=y2;ty+=25,j++)
				if( drawcell[i][j] == 1)
					g.fillRect(tx,ty,25,25);

		showStatus(status + " 1: " + String.valueOf(nlayer) + " 2: " +String.valueOf(momentumRate) + "  3: " + String.valueOf(learningRate));

                  mouseupflag = repaintflag= showNetflag =0;

	}
	    public void update(Graphics g)
	   {

          if(repaintflag ==1){
                 g.clearRect(0,0,width,height);}
           if(mousedragflag==1)
                g.clipRect(x1,y1,x2,y2);
           if(mouseupflag == 1)
                  g.clearRect(ux,uy,25,25);
          if(showNetflag ==1)
                  g.clearRect(0,y2+20,width,height-y2);

	     paint(g);
	   } 
	/************************* MOUSE-DRAG  ***********************************/


       protected void start(){
          }
       
       protected void stop(){
           cp.newframe.unMap();
          }
            
	public void mouseDrag(int x, int y)
	    {
		int i,j;
		int tx,ty;
		int l,k;

                mousedragflag = 1;
		for(tx=x1,i=0;tx<=x2-25;tx+=25,i++)
			for(ty=y1,j=0;ty<=y2-25;ty+=25,j++)
				if(x > tx && x < tx +25)
					if(y > ty && y < ty + 25)
					{
						l = (int)((x-x1)/25);
						k = (int)((y-y1)/25);
						cell[l][7-k] = 1;
						drawcell[i][j] = 1;
					}

		repaint();
	}
	/************************* MOUSE-UP  ***********************************/
	public void mouseUp(int x, int y)
	    {
		int i,j;
		int tx,ty;
		int l,k;

		if(mousedragflag ==1)
		{
			mousedragflag = 0;
			return;
		}
               mouseupflag = 1;

		for(tx=x1,i=0;tx<=x2-25;tx+=25,i++)
			for(ty=y1,j=0;ty<=y2-25;ty+=25,j++)
				if(x > tx && x < tx +25)
					if(y > ty && y < ty + 25)
						if (drawcell[i][j] == 0)
						{
							l = (int)((x-x1)/25);
							k = (int)((y-y1)/25);
							cell[l][7-k] = 1;

							drawcell[i][j] = 1 ;
						}
		else
						{
							l = (int)((x-x1)/25);
							k = (int)((y-y1)/25);
							cell[l][7-k] = 0;

							drawcell[i][j] = 0 ;
							ux = tx; 
							uy = ty;
						}
		repaint();
	}

}

/********************************************************************/
class controlPanel  
{
	Window mainWindow;
	Frame newframe;
	TextArea t;
	int noOfFile  = 10;

	public controlPanel(WServer serv,hotjava thisjava,BackProp bp)
	    {
		newframe = new Frame(serv,true,null,330,270,Color.lightGray);
		newframe.setTitle("Control Panel");

		mainWindow = new Window( newframe,"Center",Color.lightGray,100,70);

		new  saveButton(mainWindow,this,bp);
		new  showRecallButton(mainWindow,this,bp);
		new  showHiddenButton(mainWindow,this,bp);
		new  memorizeFactsButton(mainWindow,this,bp);
		new  retriveFactsButton(mainWindow,this,bp);
		new sweepFactsButton(mainWindow,this,bp);
		new printNetworkButton(mainWindow,this,bp);
		new toggleDebuggingButton(mainWindow,this,bp);
		new getNetButton(mainWindow,this,bp);
		new archiveFactsButton(mainWindow,this,bp);
		new retriveNetworkButton(mainWindow,this,bp);
		new eraseFactButton(mainWindow,this,bp);
		new clearFactsButton(mainWindow,this,bp);
		new reportNoFactsButton(mainWindow,this,bp);
		new RepaintButton(mainWindow,this,bp);
		new  quitButton(mainWindow,this,bp);

		newframe.map();
	}
}

/********************************************************************/

class quitButton extends Button 
{
	Window dwin;
	controlPanel d;
	Button b;
        BackProp bp;

	public quitButton(Window w, controlPanel cp,BackProp _bp)
	    {
		super("Quit",null,w);
		d = cp;
                bp = _bp;
	}
	public void selected(Component c, int pos)
	    {
		d.newframe.unMap();
                bp.thisjava.go("http://naos:2111/backprop/thanks.html");
                return;
	}
}
/********************************************************************/
class saveButton extends Button 
{
	Window dwin;
	controlPanel d;
	Button b;
	BackProp bp;

	public saveButton(Window w, controlPanel cp,BackProp abp)
	    {
		super("Save fact",null,w);
		d = cp;
		bp = abp;
	}
	public void selected(Component c, int pos)
	    {
		Socket sfd = new Socket("128.230.1.9",5301);
		FileOutputStream fpout;
		InetAddress iaddr = new InetAddress("128.230.1.9");
		String str = new String("vishal");
		byte b[] = new byte [20];



		str.getBytes(0,5,b,0);
		bp.drawcell[0][0] = 1;
		bp.drawcell[1][0] = 1;
		bp.drawcell[3][4] = 1;
		bp.status = "Not Yet Implemented" ;


		//    sfd = new Socket("128.230.1.9",5013);
		//    sfd.connect(iaddr,5013);
		//    sfd.listen(5);

		fpout = new FileOutputStream(bp.docRoot + "t2");

		sfd.outputStream = fpout;
		sfd.outputStream.write(b);

		bp.repaint();
	}
}

/********************************************************************/
class showRecallButton extends Button 
{
	Window dwin;
	controlPanel d;
	Button b;
	BackProp bp;
	controlPanel cp;
	String answer = new String();

	public showRecallButton(Window w, controlPanel _cp,BackProp abp)
	    {
		super("Show Recall",null,w);
		cp = _cp;
		bp = abp;
	}
	public void selected(Component c, int pos)
	    {
		FileInputStream fpin;
		DataInputStream fpdin;
		FileOutputStream fpout;
		DataOutputStream fpdout;
		FileOutputStream fpcommout;
		DataOutputStream fpdcommout;
		FileInputStream fprin;
		DataInputStream fprdin;
		byte b[];
		int i,j;
		String s;
		//   Neural  n;
		b = new byte [40];
		//  n = new Neural();

		//  for(i=0;i<32*32;i++)
		    //     n.main_loop(cell);


		fpcommout =  new FileOutputStream(bp.docRoot + "commandFile");
		fpdcommout = new DataOutputStream(fpcommout);
		fpdcommout.writeChars("recog r -1 /hpdc4/java/public_html/backprop/classes/Net /hpdc4/java/public_html/backprop/classes/data /hpdc4/java/public_html/backprop/classes/output\n");
		fpcommout.close();


		fpout =  new FileOutputStream(bp.docRoot + "data");

		fpdout = new DataOutputStream(fpout);
		for(i=0;i<32;i++)
		{
			for(j=0;j<32;j++)
			{
				//fpdout.writeChars(String.valueOf(bp.cell[i][j])+ " ");
				fpdout.writeChars(String.valueOf(bp.cell[i][j]));
				fpdout.writeChars(" ");
			}
			fpdout.writeChars("\n");
		}

		fpdout.close();
		fpout.close();




		System.exec(bp.docRoot + "recog");

		//   Wait for "C" code to write output into file

		    for(i=0;i<1000;i++)
			for(j=0;j<1000;j++);

		fpin =  new FileInputStream(bp.docRoot + "output");
		fpdin = new DataInputStream(fpin);
		answer =fpdin.readLine();

		fpin.close();
		fpdin.close();


		fprin =  new FileInputStream(bp.docRoot + "netResult");
		fprdin = new DataInputStream(fprin);

		for(i=0;i<26;i++)
			bp.netResult[i] = fprdin.readLine();
                 
               bp.atleastOnce = true;



	//	  showNetResult snr;
//		  snr = new showNetResult();
//		snr.dummyStart(cp.newframe.wServer,cp,bp);
		//  snr.init();

		bp.status = "Found [" + answer + "]"  + "first " + bp.netResult[0] + " last " + bp.netResult[25] ;
		bp.showNetflag= 1;
		bp.repaint();

		//    bp.thisjava.go("http://web.syr.edu/~furm/backprop/t.html");
//		new anotherTry(newframe.wServer);


	}
}
/********************************************************************/
class showHiddenButton extends Button 
{
	Window dwin;
	controlPanel d;
	Button b;
	BackProp bp;

	public showHiddenButton(Window w, controlPanel cp,BackProp abp)
	    {
		super("Show Hidden",null,w);
		d = cp;
		bp = abp;
	}
	public void selected(Component c, int pos)
	    {
		bp.status = "Not Yet Implemented" ;
		bp.repaint();
	}
}
/********************************************************************/
class memorizeFactsButton extends Button 
{
	Window dwin;
	controlPanel d;
	Button b;
	BackProp bp;

	public memorizeFactsButton(Window w, controlPanel cp,BackProp abp)
	    {
		super("Memorize Facts",null,w);
		d = cp;
		bp = abp;
	}
	public void selected(Component c, int pos)
	    {
		bp.status = "Not Yet Implemented" ;
		bp.repaint();
	}
}
/********************************************************************/

class retriveFactsButton extends Button 
{
	Window dwin;
	controlPanel d;
	Button b;
	BackProp bp;

	public retriveFactsButton(Window w, controlPanel cp,BackProp abp)
	    {
		super("Retrieve Facts",null,w);
		d = cp;
		bp = abp;
	}
	public void selected(Component c, int pos)
	    {
		bp.status = "Not Yet Implemented" ;
		bp.repaint();
	}
}
/********************************************************************/

class sweepFactsButton extends Button 
{
	Window dwin;
	controlPanel d;
	Button b;
	BackProp bp;

	public sweepFactsButton(Window w, controlPanel cp,BackProp abp)
	    {
		super("Sweep Facts",null,w);
		d = cp;
		bp = abp;
	}
	public void selected(Component c, int pos)
	    {
		bp.status = "Not Yet Implemented" ;
		bp.repaint();
	}
}
/********************************************************************/

class printNetworkButton extends Button 
{
	Window dwin;
	controlPanel d;
	Button b;
	BackProp bp;

	public printNetworkButton(Window w, controlPanel cp,BackProp abp)
	    {
		super("Print Network",null,w);
		d = cp;
		bp = abp;
	}
	public void selected(Component c, int pos)
	    {
		bp.status = "Not Yet Implemented" ;
		bp.repaint();
	}
}
/********************************************************************/

class getNetButton extends Button 
{
	Window dwin;
	controlPanel d;
	Button b;
	BackProp bp;

	public getNetButton(Window w, controlPanel cp,BackProp abp)
	    {
		super("Network",null,w);
		d = cp;
		bp = abp;
	}
	public void selected(Component c, int pos)
	    {
		bp.status = "Not Yet Implemented" ;
		bp.repaint();
	}
}
/********************************************************************/

class toggleDebuggingButton extends Button 
{
	Window dwin;
	controlPanel d;
	Button b;
	BackProp bp;

	public toggleDebuggingButton(Window w, controlPanel cp,BackProp abp)
	    {
		super("Debug",null,w);
		d = cp;
		bp = abp;
	}
	public void selected(Component c, int pos)
	    {
		bp.status = "Not Yet Implemented" ;
		bp.repaint();
	}
}

/********************************************************************/
class archiveFactsButton extends Button 
{
	Window dwin;
	controlPanel d;
	Button b;
	BackProp bp;

	public archiveFactsButton(Window w, controlPanel cp,BackProp abp)
	    {
		super("Archive Facts",null,w);
		d = cp;
		bp = abp;
	}
	public void selected(Component c, int pos)
	    {
		bp.status = "Not Yet Implemented" ;
		bp.repaint();
	}
}
/********************************************************************/
class retriveNetworkButton extends Button 
{
	Window dwin;
	controlPanel d;
	Button b;
	BackProp bp;

	public retriveNetworkButton(Window w, controlPanel cp,BackProp abp)
	    {
		super("Retrieve Network",null,w);
		d = cp;
		bp = abp;
	}
	public void selected(Component c, int pos)
	    {
		RandomAccessFile file;

		file = new RandomAccessFile("/hpdc4/java/public_html/backprop/classes/dummy","r");

		bp.nlayer = file.readInt();
		bp.learningRate = file.readInt();
		bp.momentumRate = file.readInt();

		bp.status = "Retrieve  NEtwork Not Yet Implemented" ;
		bp.repaint();
	}
}
/********************************************************************/
class eraseFactButton extends Button 
{
	Window dwin;
	controlPanel d;
	Button b;
	BackProp bp;

	public eraseFactButton(Window w, controlPanel cp,BackProp abp)
	    {
		super("Erase Fact",null,w);
		d = cp;
		bp = abp;
	}
	public void selected(Component c, int pos)
	    {
		bp.status = "Not Yet Implemented" ;
		bp.repaint();
	}
}
/********************************************************************/
class clearFactsButton extends Button 
{
	Window dwin;
	controlPanel d;
	Button b;
	BackProp bp;

	public clearFactsButton(Window w, controlPanel cp,BackProp abp)
	    {
		super("Clear all Facts",null,w);
		d = cp;
		bp = abp;
	}
	public void selected(Component c, int pos)
	    {
		bp.status = "Not Yet Implemented" ;
		bp.repaint();
	}
}
/********************************************************************/

class reportNoFactsButton extends Button 
{
	Window dwin;
	controlPanel d;
	Button b;
	BackProp bp;

	public reportNoFactsButton(Window w, controlPanel cp,BackProp abp)
	    {
		super("Number of facts",null,w);
		d = cp;
		bp = abp;
	}
	public void selected(Component c, int pos)
	    {
		bp.status = "Not Yet Implemented" ;
		bp.repaint();
	}
}
class RepaintButton extends Button 
{
	Window dwin;
	controlPanel d;
	Button b;
	BackProp bp;

	public RepaintButton(Window w, controlPanel cp,BackProp abp)
	    {
		super("Repaint",null,w);
		d = cp;
		bp = abp;
	}
	public void selected(Component c, int pos)
	    {
		int i,j;

		for(i=0;i<32;i++)
			for(j=0;j<32;j++)
			{
				bp.cell[i][j] = 0;
			}
		for(i=0;i<8;i++)
			for(j=0;j<8;j++)
			{
				bp.drawcell[i][j] = 0;
			}
		bp.repaintflag = 1;
                bp.showNetflag = 0;
		bp.ux = -200;

		bp.status = "Repainted" ;
                bp.atleastOnce = false;
		bp.repaint();
	}
}

class showNetResult extends Applet
{
	Frame thisframe;
	Window thiswin;
	hotjava thisjava;
	Frame newframe;
	Window mainWindow;
	Graphics g;


	/*************************   INIT  ***********************************/

	public void init()
	    {

		while((( thiswin = item.parent) == null) &&
		    (( item.getStatus() == AppletDisplayItem.STARTED) ||
		    ( item.getStatus() == AppletDisplayItem.INITIALIZING))) ;

		thisframe = thiswin.getFrame();
		thisjava =(hotjava) thisframe ;
		resize(600,800);
		repaint();
	}

	public void paint(Graphics g){
		g.drawString("HI THERE",10,10);
	}




	public void dummyStart(WServer serv,controlPanel _cp,BackProp bp)
	    {
              int i,h;
              Float f; 
		newframe = new Frame(serv,true,null,330,270,Color.lightGray);
		newframe.setTitle("Network Result");

		mainWindow = new Window(newframe,"Center",Color.lightGray,100,70);

                mainWindow.map();
		newframe.map();
		g = new Graphics(mainWindow,100,100,300,300);
		 g.drawString("THIS IS A TEST MESSAGE",50,50);

		  for(i=0;i<26;i++)
		      { 
		       f = Float.valueOf(bp.netResult[i]);
		       h = f.intValue();
		      g.paint3DRect(i*10 +10,10,7,h,true,true);
		     }
//		mainWindow.drawString("THIS IS A TEST",50,50);
//		newframe.map();
	}
}

/*
class anotherTry extends hotjava{
Frame newframe;
 
 
  anotherTry(WServer _serv){
   newframe = new Frame(_serv,true,null,330,270,Color.lightGray);
   newframe.setTitle("Network Result");
    super((hotjava)newframe,null);
     }
}
*/
