/*

		First try at a hotjava controller for demo use, its not meant
		to be a complete program just a test to see if some things
		work the way we want.


		daniel@vpro.nl (Daniel Ockeloen)

*/

import awt.*;
import java.lang.*;
import java.util.*;
import browser.*;
import net.www.html.*;
import Object;
import java.io.*;



class  note implements Runnable{

	/* Popup window parts */

	Window mainWindow;
	Window TextWindow;
	MenuBar	mbar;
	Menu mfile;
	Frame  newframe;
	Thread runner=null;
	WServer wServ;
	hotjava thj;
	TextArea t;
	String commandtext;
	String subtext;
	boolean waitsig=false;
	String scripttext;

	public  note(WServer serv,hotjava thisjava, String stext) {

		scripttext=stext;
		wServ = serv;
	 	thj=thisjava; 

		/* Create new Frame */
		newframe = new Frame(serv,true,null,330,270,Color.lightGray);
		newframe.setTitle("Hotjava control");

		/* Create window in this frame */
		mainWindow=new Window(newframe,"Center",Color.lightGray,330,270);

		/* Create Menu bar */
		Font menuFont = serv.fonts.getFont("Dialog", Font.BOLD, 12);
		newframe.setDefaultFont(menuFont);
		mbar=new MenuBar(newframe);
		
		/* Create first menu bar popup */
		new WindowMenu("File",mbar,this,newframe,t);

		/* Create text area for the control script */
		Font defaultFont = serv.fonts.getFont("Courier", Font.PLAIN, 14);
		t = new TextArea(mainWindow, "Center", defaultFont, 80,8); 
		t.setText(scripttext);
		t.setHFill(true);

		/* Create Reload button */
		new ReloadTextButton(mainWindow,this);

		/* Create cont button */
		new ContTextButton(mainWindow,this);

		/* Frame ready so show Frame to the uses */
		newframe.map();
	}
	
	

	public void run() {

		String command;

		/* start time between commands */
		int    waittime=5;

		/*  min time between commands */
		int    minwaittime=10;

		/* Temp vars */
		Integer at;
		String templine;
		
		/* Get Text from window area */
		commandtext=t.getText();
		subtext=commandtext;

		/* main loops keeps running until either user closes window or hotjava is stopped */
		while (runner!=null) {
		
			/* Get next command */
			if (subtext.indexOf("\n")!=-1) {
				command=subtext.substring(0,subtext.indexOf("\n"));
				subtext=subtext.substring(subtext.indexOf("\n")+1);
			} else {
				command=subtext;
				subtext=commandtext;	
			}

			/* Some bebug info */
			mainWindow.clearRect(1,1,300,300);
			mainWindow.setForeground(Color.darkGray);
			mainWindow.drawString("Current command : ",10,220);
			if (command.length()>49) {
				mainWindow.drawString(command.substring(0,49),10,235);
			} else {
				mainWindow.drawString(command,10,235);
			}

			/* show page command found */
			if (command.indexOf("show")==0) {
				templine=command.substring(5);
				thj.go(templine);				
				Thread.sleep(minwaittime*1000);
			}	

			/* wait for mouse kick */
			if (command.indexOf("mouse")==0) {
				waitsig=true;
				while (waitsig==true) {
					Thread.sleep(1000);
				}
			}

			/* extra wait command found */
			if (command.indexOf("wait")==0) {
				templine=command.substring(5);
				at = new Integer(templine);
				waittime=at.intValue();
			 	if ((waittime-minwaittime)>0) {
					Thread.sleep((waittime-minwaittime)*1000);
				}
			}	


			/* new minwait time */
			if (command.indexOf("minwait")==0) {
				templine=command.substring(8);
				at = new Integer(templine);
				minwaittime=at.intValue();
			}	


			
		}
	}

	 /* called when the reload button is pressed */
	 public void cont() {
		waitsig=false;
	 }

	 /* called when the reload button is pressed */
	 public void reloadtext() {

		/* get new command text from window and reset loop */
		commandtext=t.getText();
		subtext=commandtext;	
	 }


	/* start the controller thread */
	 public void start() {
		if (runner==null) {
			runner=new Thread(this);
			runner.start();
		}
	}

	/* stop controller thread */	
	public void stop() {
		runner=null;
		newframe.unMap();
	}

	/* stop controller thread */	
	public void destroy() {
		runner=null;
		newframe.unMap();
	}

	/* create copy of the controller */
	public void makeclone() {
	note note1;
		note1=new note(wServ,thj,scripttext);
		note1.start();
	}

}


class control extends Applet {

	/* Vars mosty to find correct handlers */
	Window thiswin;
	Frame  thisframe;
	hotjava thisjava;
	note	note1;
	String inputfile;
	String scripttext=new String(),scriptbuf;
	URL	texturl;

	/* 
 	 *	init : 
	 *
	 */ 
	public void init() {
		InputStream in = null;

		if (getAttribute("script")!=null) {
			inputfile = new String(getAttribute("script"));
		texturl = new URL(null,inputfile);

		/* This will read a URL without parsing */
		try {
			in = texturl.openStream();
		} catch	(FileNotFoundException e) {
		 	return;
		}
		byte	buffer[] = new byte[1024];
		while (true) {
			int n = in.read(buffer,	0, buffer.length);
			if (n < 0) {
				break;
			}
			scriptbuf=new String(buffer,n);
			scripttext=scripttext+scriptbuf;
		}
		in.close();
		} else {
			scripttext="show doc:///index.html\nshow doc:///demo/hangman.html\nwait 10\nshow doc:///demo/bounce.html";	
		}

		/* Find the current window we are in */
		while (((thiswin = item.parent) == null) &&
	       		((item.getStatus() == AppletDisplayItem.STARTED) ||
			(item.getStatus() == AppletDisplayItem.INITIALIZING))) {
		}

		/* Get Frame of current window (is the main hotjava frame */
		thisframe=thiswin.getFrame();

		/* Im almost sure its the same frame so lets asume this */
		thisjava=(hotjava)thisframe;

		/* Create a controller windos */
		note1=new note(thisframe.wServer,thisjava,scripttext);
		note1.start();
	}

}

/* reload button and calls reloadtext() in note if user hits it */
class ReloadTextButton extends Button {
	public ReloadTextButton(Container w, note jp) {
		super("Restart this script", null, w);
		notewin = jp;
	}	

	public void selected(Component c, int pos) {
		notewin.reloadtext();
	}

	note notewin;
}



/* Continue button and calls cont() in note if user hits it */
class ContTextButton extends Button {
	public ContTextButton(Container w, note jp) {
		super("Mouse", null, w);
		notewin = jp;
	}	

	public void selected(Component c, int pos) {
		notewin.cont();
	}

	note notewin;
}


/* pulldown window */
class WindowMenu extends Menu {

	FileDialog fdialog = null;
	Frame mf;
	TextArea mt;

	/* Create menu */
	public WindowMenu(String title,MenuBar mbar, note w, Frame f, TextArea t) {
		super(title,mbar);

		mw = w;
		mf = f;
		mt = t;
	
		MenuItem item;

		/* Create menu items and turn them off when needed */
		item = new MenuItem("Clone", this);
		item = new MenuItem("Load", this);
		item.disable();
		item = new MenuItem("Save", this);
		item.disable();
		item = new MenuItem("Save As", this);
		item = new MenuItem("Quit", this);
	}

	/* user selected one of the items, find out which and act on it */
	public void selected(int index) {
		switch(index) {
			case 0:
				/* call note.makeclone() to create a new controller */
				mw.makeclone();
				break;
			case 1:
				break;
			case 2:
				break;
			case 3:
				/* Save current script (doesn't work yet) */
				if (fdialog == null) {
					fdialog = new FileDialog("Save", mf);
				}
				String path = fdialog.chooseFile(null);
				if (path != null) {
					File fpath = new File(path);
					PrintStream pStr = new PrintStream(new FileOutputStream(fpath));
					pStr.print(mt.getText());
					pStr.close();
					
				}
				break;
			case 4:
				/* call note.stop() to kill this controller */
				mw.stop();
				break;
			default:
				break;
		}
	} note mw;
}
