#include<stdio.h>
#include<math.h>
/*
#include <X11/keysym.h>
*/

#include "StubPreamble.h"
#include "javaString.h"
#include "gks.h"
#include "GKS3D_GKS.h"

#define INIT_GC(disp, gdata)\
if (gdata==0 || gdata->gc == 0 && !awt_init_gc(disp,gdata)) {\
    return;\
}

#define INIT_GC2(disp, gdata, rval)\
if (gdata==0 || gdata->gc == 0 && !awt_init_gc(disp,gdata)) {\
    return rval;\
}

#define OX(this)        (unhand(this)->originX)
#define OTY(this)       (unhand(this)->originY)
#define SX(this)        (unhand(this)->scaleX)
#define STY(this)       (unhand(this)->scaleY)
#define TX(this, x)     (((int)((x) * SX(this))) + OX(this))
#define TY(this, y)    (((int)((y) * STY(this))) + OTY(this))
#define TW(this, w)     ((int)((w) * SX(this)))
#define TH(this, h)     ((int)((h) * STY(this)))



void
GKS3D_GKS_fillPoly(HGKS3D_GKS *this,Hawt_WServer wServer,
               long x1,
               long y1,
               long x2,
               long y2,
               long x3,
               long y3,
               long x4,
               long y4)
{
    struct GraphicsData *gdata;
    XPoint point2d;
    int i;

    if (this == 0) {
    SignalError(0, JAVAPKG "NullPointerException", 0);
    return;
    }

   i=0;
   point2d[i].x = TX(this,x1);point2d[i].y = TY(this,y1) ; i++;
   point2d[i].x = TX(this,x2);point2d[i].y = TY(this,y2) ; i++;
   point2d[i].x = TX(this,x3);point2d[i].y = TY(this,y3) ; i++;
   point2d[i].x = TX(this,x4);point2d[i].y = TY(this,y4) ; i++;

    gdata =PDATA(GraphicsData,this);
    INIT_GC(DSPU(unhand(this->wServer)), gdata);
    XFillRectangle(DSPU(this->wServer),
           gdata->drawable,
           gdata->gc,
           point2d,4,Nonconvex,CoordModeOrigin));
}

