import browser.Applet;
import awt.Button;
import awt.Color;
import awt.Component;
import awt.Font;
import awt.Frame;
import awt.Graphics;
import awt.Menu;
import awt.MenuBar;
import awt.MenuItem;
import awt.TextArea;
import awt.Window;
import awt.WServer;
import java.util.Vector;
import awt.FileDialog;
import java.io.File;
import java.io.FileInputStream;
import browser.hotjava;

class HelloWorld_10 extends Applet		{
	String fontType = "Helvetica", fontStyle = "BOLD", fontColor = "blue",
		fontSize = "36";
	int fontStyleValue = Font.BOLD, fontSizeValue = 36;
	Color fontColorValue = Color.blue;
	Color winColorValue = Color.pink;
	MenuBar mb;
	MenuItem tpmit, stmit, clmit, szmit;
	String fontTypeList[] = 	{
		"Helvetica",	"TimesRoman",	"ZapfDingbats",
		"Dialog",	"DialogInput",	"Courier"
					};
	String fontStyleList[] =	{
		"PLAIN",	"BOLD",		"ITALIC",
		"UNDERLINE"
					};
	int fontStyleVec[] =		{
		Font.PLAIN,	Font.BOLD,	Font.ITALIC,
		Font.UNDERLINE
					};
	String fontColorList[] =	{
		"black",	"blue",		"cyan",		"darkGray",
		"gray",		"green",	"magenta",	"menuBack",
		"menuBright",	"menuDim",	"menuFore",
		"menuHighlight",		"orange",	"pink",
		"red",		"white",	"yellow"
					};
	Color fontColorVec[] =		{
		Color.black,	Color.blue,	Color.cyan,	Color.darkGray,
		Color.gray,	Color.green,	Color.magenta,	Color.menuBack,
		Color.menuBright,		Color.menuDim,
		Color.menuFore,	Color.menuHighlight,		Color.orange,
		Color.pink,	Color.red,	Color.white,	Color.yellow
					};
	String fontSizeList[] =		{
		"8",	"10",	"12",	"14",	"24",	"36"
					};
	int fontSizeVec[] =		{
		8,	10,	12,	14,	24,	36
					};
	FontTypeMenu ftpm;
	FontStyleMenu fstm;
	FontColorMenu fclm;
	FontSizeMenu fszm;
	FileMenu film;
	Frame frame;
	FileDialog fileBox;
	String fileName;
	String fileValue;
	FileInputStream fileStream;
	byte fileBytes[];
	int fileSize;
	Font helloFont;
	Window mainWin;
	Window hjWin;
	Frame hjFrame;
	hotjava browser;
	TextArea txtArea;
	String helloStr = "Hello World!";
	boolean helloPaint;
	Paragraph paragraph;

	public void init()		{
		resize(650,450);
		fileValue = "Select file using FileDialog at File->Open";
		helloPaint = true;
					}
	public void paint(Graphics g)	{
		int x=200, y=260;

	if(helloPaint)	{
		helloFont = getFont(fontType,fontStyleValue,fontSizeValue);
		g.setFont(helloFont);
		g.setForeground(getColor(200,200,200));
		g.paint3DRect(0,0,650,450,true,true);
		g.setForeground(fontColorValue);
		g.drawString(helloStr,x,y);
		showStatus("Type="+fontType+" Style="+fontStyle+" Color="
		+fontColor+" Size="+fontSize);
			}
	else		{
		 helloFont = getFont(fontType,fontStyleValue,fontSizeValue);
                g.setFont(helloFont);
                g.setForeground(getColor(200,200,200));
                g.paint3DRect(0,0,650,450,true,true);
                g.setForeground(fontColorValue);
		paragraph.paint(g,helloFont);
			}
					}
	protected void start()		{
		hjWin = item.parent;
		hjFrame = hjWin.getFrame();
		WServer ws = hjFrame.wServer;
		frame = new Frame(ws,true,browser,740,680,Color.pink);
		frame.setTitle("Foil Editor Panel");
		frame.setDefaultFont(getFont("TimesRoman",Font.ITALIC,24));
		mb = new MenuBar(frame);
		fileBox = new FileDialog("FileBox",frame);
		film = new FileMenu("File",mb,true,this);
		ftpm = new FontTypeMenu("FontType",mb,true,this);
		fstm = new FontStyleMenu("FontStyle",mb,true,this);
		fclm = new FontColorMenu("FontColor",mb,true,this);
		fszm = new FontSizeMenu("FontSize",mb,true,this);
		Window mainWin = new Window(frame,"Center",
			winColorValue,740,680);
		Font ft = getFont("Courier",Font.PLAIN,14);
		txtArea = new TextArea(mainWin,"Center",ft,80,40);
		txtArea.setEditable(true); 
		txtArea.setText(fileValue);
		frame.map();
					}
	protected void stop()		{
//	frame.unMap(); frame.dispose();
			frame.unMap();
					}

	public void fetchFile(String _name)	{
		fileName = _name;
		File file = new File(_name);
		String stat = "FILE="+fileName;
		if(file.isFile())	{
			fileStream = new FileInputStream(_name);
			fileSize = fileStream.available();
			stat += " LENGTH="+String.valueOf(fileSize);
			showStatus(stat);
			fileBytes = new byte[fileSize];
			fileStream.read(fileBytes);
			fileValue = new String(fileBytes,0,0,fileSize);
			paragraph = new Paragraph(fileBytes,helloFont,
				fontColorValue,winColorValue,
				0,0,650,450);
			helloPaint = false;
			stop(); start();
					}
		showStatus(stat);
						}
						}
  
class FontTypeMenu extends Menu			{
	
	Vector mitv;
	HelloWorld_10 app;

public FontTypeMenu(String _key, MenuBar _mb, boolean _b, HelloWorld_10 _app) 
								{
		super(_key,_mb,_b);
		MenuItem mit;
		app = _app;
		mitv = new Vector();
		int i; boolean mark;
		for(i=0; i<app.fontTypeList.length; i++)	{
			mark =
			(app.fontType.compareTo(app.fontTypeList[i]) == 0) ?
			true : false;
			mit = new MenuItem(app.fontTypeList[i],this,true);
			if(mark) { mit.setMark(true);  app.tpmit = mit; }
			mitv.addElement(mit);
								}
								}
	public void selected(int index)	{
		MenuItem mit = (MenuItem)mitv.elementAt(index);
		app.tpmit.setMark(false);
		mit.setMark(true);
		app.tpmit = mit;
		app.fontType = mit.label;
		app.repaint();
					}
						}


class FontStyleMenu extends Menu		{
	Vector mitv;
	HelloWorld_10 app;

public FontStyleMenu(String _key, MenuBar _mb, boolean _b, HelloWorld_10 _app) 
								{
		super(_key,_mb,_b);
		MenuItem mit;
		app = _app;
		mitv = new Vector();
		int i; boolean mark;
		for(i=0; i<app.fontStyleList.length; i++)        {
			mark =
			(app.fontStyle.compareTo(app.fontStyleList[i]) == 0) ?
			true : false;
			mit = new MenuItem(app.fontStyleList[i],this,true);
			if(mark) { mit.setMark(true);  app.stmit = mit; }
			mitv.addElement(mit);
								}
								}
	public void selected(int index) {
		MenuItem mit = (MenuItem)mitv.elementAt(index);
		app.stmit.setMark(false);
		mit.setMark(true);
		app.stmit = mit;
		app.fontStyle = mit.label;
		app.fontStyleValue = app.fontStyleVec[index];
		app.repaint();
					}

						}

class FontColorMenu extends Menu		{
	Vector mitv;
	HelloWorld_10 app;

public FontColorMenu(String _key, MenuBar _mb, boolean _b, HelloWorld_10 _app)
								{
		super(_key,_mb,_b);
		MenuItem mit;
		app = _app;
		mitv = new Vector();
		int i; boolean mark;
		for(i=0; i<app.fontColorList.length; i++)        {
			mark =
			(app.fontColor.compareTo(app.fontColorList[i]) == 0) ?
			true : false;
			mit = new MenuItem(app.fontColorList[i],this,true);
			if(mark) { mit.setMark(true);  app.clmit = mit; }
			mitv.addElement(mit);
								}
								}
	public void selected(int index)	{
		MenuItem mit = (MenuItem)mitv.elementAt(index);
		app.clmit.setMark(false);
		mit.setMark(true);
		app.clmit = mit;
		app.fontColor = mit.label;
		app.fontColorValue = app.fontColorVec[index];
		app.repaint();
					}
						}

class FontSizeMenu extends Menu			{
	Vector mitv;
	HelloWorld_10 app;

public FontSizeMenu(String _key, MenuBar _mb, boolean _b, HelloWorld_10 _app)
								{
		super(_key,_mb,_b);
		MenuItem mit;
		app = _app;
		mitv = new Vector();
		int i; boolean mark;
		for(i=0; i<app.fontSizeList.length; i++)        {
			mark =
			(app.fontSize.compareTo(app.fontSizeList[i]) == 0) ?
			true : false;
			mit = new MenuItem(app.fontSizeList[i],this,true);
			if(mark) { mit.setMark(true);  app.szmit = mit; }
			mitv.addElement(mit);
								}
								}
	public void selected(int index) {
		MenuItem mit = (MenuItem)mitv.elementAt(index);
		app.szmit.setMark(false);
		mit.setMark(true);
		app.szmit = mit;
		app.fontSize = mit.label;
		app.fontSizeValue = app.fontSizeVec[index];
		app.repaint();
					}
						}

class FileMenu extends Menu	{
	Vector mitv;
	HelloWorld_10 app;

public FileMenu(String _key, MenuBar _mb, boolean _b, HelloWorld_10 _app)
								{
                super(_key,_mb,_b);
                MenuItem mit;
                app = _app;
                mitv = new Vector();
		mit = new MenuItem("New",this,true);
		mitv.addElement(mit);
		mit = new MenuItem("Open...",this,true);
		mitv.addElement(mit);
		mit = new MenuItem("Reload",this,true);
		mitv.addElement(mit);
		mit = new MenuItem("Repaint",this,true);
		mitv.addElement(mit);
		mit = new MenuItem("Redraw",this,true);
		mitv.addElement(mit);
		mit = new MenuItem("Save",this,true);
		mitv.addElement(mit);
		mit = new MenuItem("Save As...",this,true);
		mitv.addElement(mit);
		mit = new MenuItem("Quit",this,true);
		mitv.addElement(mit);
		mit = new MenuItem("Exit",this,true);
		mitv.addElement(mit);
								}

	public void selected(int index)	{
		MenuItem mit = (MenuItem)mitv.elementAt(index);
		if(mit.label.compareTo("Open...") == 0)	{
			String path = app.fileBox.chooseFile(null);
			app.fetchFile(path);
							}
					}
				}
