import browser.Applet;
import awt.Button;
import awt.ChildList;
import awt.Color;
import awt.Component;
import awt.Font;
import awt.Frame;
import awt.Graphics;
import awt.Menu;
import awt.MenuBar;
import awt.MenuItem;
import awt.Window;
import awt.WServer;
import java.util.Enumeration;
import java.util.Vector;

class HelloWorld_8 extends Applet		{
	String fontType = "Helvetica", fontStyle = "BOLD", fontColor = "green",
		fontSize = "36";
	int fontStyleValue = Font.BOLD, fontSizeValue = 36;
	Color fontColorValue = Color.green;
	MenuBar hjmb;
	MenuItem tpmit, stmit, clmit, szmit;
	String fontTypeList[] = 	{
		"Helvetica",	"TimesRoman",	"ZapfDingbats",
		"Dialog",	"DialogInput",	"Courier"
					};
	String fontStyleList[] =	{
		"PLAIN",	"BOLD",		"ITALIC",
		"UNDERLINE"
					};
	int fontStyleVec[] =		{
		Font.PLAIN,	Font.BOLD,	Font.ITALIC,
		Font.UNDERLINE
					};
	String fontColorList[] =	{
		"black",	"blue",		"cyan",		"darkGray",
		"gray",		"green",	"magenta",	"menuBack",
		"menuBright",	"menuDim",	"menuFore",
		"menuHighlight",		"orange",	"pink",
		"red",		"white",	"yellow"
					};
	Color fontColorVec[] =		{
		Color.black,	Color.blue,	Color.cyan,	Color.darkGray,
		Color.gray,	Color.green,	Color.magenta,	Color.menuBack,
		Color.menuBright,		Color.menuDim,
		Color.menuFore,	Color.menuHighlight,		Color.orange,
		Color.pink,	Color.red,	Color.white,	Color.yellow
					};
	String fontSizeList[] =		{
		"8",	"10",	"12",	"14",	"24",	"36"
					};
	int fontSizeVec[] =		{
		8,	10,	12,	14,	24,	36
					};
	FontTypeMenu ftpm;
	FontStyleMenu fstm;
	FontColorMenu fclm;
	FontSizeMenu fszm;

	public void init()		{
		resize(600,100);
					}
	public void paint(Graphics g)	{
		String str = "Hello World!";
		int x=200, y=60;

		Font f = getFont(fontType,fontStyleValue,fontSizeValue);
		g.setFont(f);
		g.setForeground(getColor(200,200,200));
		g.paint3DRect(0,0,600,100,true,true);
		g.setForeground(fontColorValue);
		g.drawString(str,x,y);
		showStatus("Type="+fontType+" Style="+fontStyle+" Color="
		+fontColor+" Size="+fontSize);
					}
	protected void start()		{
		Frame hjfr = item.parent.getFrame();
//	hjfr.background = Color.pink; hjfr.map();
		ChildList chl = hjfr.children;
		Enumeration kv = chl.keys();
		for(Enumeration ev = chl.elements(); ev.hasMoreElements() ;)  {
			kv.hasMoreElements();	
			Object ee = ev.nextElement();
			Object ek = kv.nextElement();
			String name = ee.getClass().getName();
			if(name.compareTo("awt.MenuBar") == 0)	{
				hjmb = (MenuBar)ee;
								}
									}
		ftpm = new FontTypeMenu("FontType",hjmb,true,this);
		fstm = new FontStyleMenu("FontStyle",hjmb,true,this);
		fclm = new FontColorMenu("FontColor",hjmb,true,this);
		fszm = new FontSizeMenu("FontSize",hjmb,true,this);
					}
	protected void stop()		{
//		fszm.dispose(); fclm.dispose();
//		fstm.dispose(); ftpm.dispose();
		fszm.hide();
		fclm.hide();
		fstm.hide();
		ftpm.hide();
					}
						}
  
class FontTypeMenu extends Menu			{
	
	Vector mitv;
	HelloWorld_8 app;

public FontTypeMenu(String _key, MenuBar _mb, boolean _b, HelloWorld_8 _app) 
								{
		super(_key,_mb,_b);
		MenuItem mit;
		app = _app;
		mitv = new Vector();
		int i; boolean mark;
		for(i=0; i<app.fontTypeList.length; i++)	{
			mark =
			(app.fontType.compareTo(app.fontTypeList[i]) == 0) ?
			true : false;
			mit = new MenuItem(app.fontTypeList[i],this,true);
			if(mark) { mit.setMark(true);  app.tpmit = mit; }
			mitv.addElement(mit);
								}
								}
	public void selected(int index)	{
		MenuItem mit = (MenuItem)mitv.elementAt(index);
		app.tpmit.setMark(false);
		mit.setMark(true);
		app.tpmit = mit;
		app.fontType = mit.label;
		app.repaint();
					}
						}


class FontStyleMenu extends Menu		{
	Vector mitv;
	HelloWorld_8 app;

public FontStyleMenu(String _key, MenuBar _mb, boolean _b, HelloWorld_8 _app) 
								{
		super(_key,_mb,_b);
		MenuItem mit;
		app = _app;
		mitv = new Vector();
		int i; boolean mark;
		for(i=0; i<app.fontStyleList.length; i++)        {
			mark =
			(app.fontStyle.compareTo(app.fontStyleList[i]) == 0) ?
			true : false;
			mit = new MenuItem(app.fontStyleList[i],this,true);
			if(mark) { mit.setMark(true);  app.stmit = mit; }
			mitv.addElement(mit);
								}
								}
	public void selected(int index) {
		MenuItem mit = (MenuItem)mitv.elementAt(index);
		app.stmit.setMark(false);
		mit.setMark(true);
		app.stmit = mit;
		app.fontStyle = mit.label;
		app.fontStyleValue = app.fontStyleVec[index];
		app.repaint();
					}

						}

class FontColorMenu extends Menu		{
	Vector mitv;
	HelloWorld_8 app;

public FontColorMenu(String _key, MenuBar _mb, boolean _b, HelloWorld_8 _app)
								{
		super(_key,_mb,_b);
		MenuItem mit;
		app = _app;
		mitv = new Vector();
		int i; boolean mark;
		for(i=0; i<app.fontColorList.length; i++)        {
			mark =
			(app.fontColor.compareTo(app.fontColorList[i]) == 0) ?
			true : false;
			mit = new MenuItem(app.fontColorList[i],this,true);
			if(mark) { mit.setMark(true);  app.clmit = mit; }
			mitv.addElement(mit);
								}
								}
	public void selected(int index)	{
		MenuItem mit = (MenuItem)mitv.elementAt(index);
		app.clmit.setMark(false);
		mit.setMark(true);
		app.clmit = mit;
		app.fontColor = mit.label;
		app.fontColorValue = app.fontColorVec[index];
		app.repaint();
					}
						}

class FontSizeMenu extends Menu			{
	Vector mitv;
	HelloWorld_8 app;

public FontSizeMenu(String _key, MenuBar _mb, boolean _b, HelloWorld_8 _app)
								{
		super(_key,_mb,_b);
		MenuItem mit;
		app = _app;
		mitv = new Vector();
		int i; boolean mark;
		for(i=0; i<app.fontSizeList.length; i++)        {
			mark =
			(app.fontSize.compareTo(app.fontSizeList[i]) == 0) ?
			true : false;
			mit = new MenuItem(app.fontSizeList[i],this,true);
			if(mark) { mit.setMark(true);  app.szmit = mit; }
			mitv.addElement(mit);
								}
								}
	public void selected(int index) {
		MenuItem mit = (MenuItem)mitv.elementAt(index);
		app.szmit.setMark(false);
		mit.setMark(true);
		app.szmit = mit;
		app.fontSize = mit.label;
		app.fontSizeValue = app.fontSizeVec[index];
		app.repaint();
					}
						}
