/*
 * @(#)Client.java     95/09/11 95/12/18 Vishal Mehra
 * Distributed WhiteBoard
 */


/**
 * Client  is an applet which  connect to server and exchange information 
 *through it.

 * @see Server
 * @version 1.0 18 Dec 1995
 * @author Vishal Mehra
 */



import java.io.InputStream ;
import java.io.*;
import java.util;
import java.lang.* ;
import net.*;
import browser.Applet ;
import awt.Graphics ;
import awt.Color ;
import awt.DisplayItem;

class Client extends Applet implements Runnable {
//startMainClient pstartMainClient;
String IP = new String("128.230.7.14");
int port=1080;
final int Up = 1, Left = 2, Down = 3, Right = 4;
int event = 0;
int speed = 10;
checking Client;
int clearx,cleary,clearw,clearh;
int prevx,prevy,prevw,prevh;
Color color =Color.yellow;

int x,y;
boolean key = false;

     public void init(){

       x = y = 0;
       clearx = cleary = 0;
       clearw = clearh = 10;
       resize(1000,800);
       repaint();
       new Thread(this).start();
         }

     public void paint(Graphics g){
            g.drawRect(0,0,500,500);
            g.setForeground(Color.red); 
         //   g.fillRect(0,0,500,500);
            g.setForeground(Color.green);
            g.drawString("Up",210,520);
            g.drawString("Down",210,620);
            g.drawString("Left",160,570);
            g.drawString("Right",260,570);
            g.setForeground(color); 
            g.fillRect(x,y,20,20);
           if(key)   g.drawString("YOU JUST PRESSED A KEY ",10,10);
              }
    public void update(Graphics g){

        g.clearRect(clearx,cleary,clearw,clearh);
        g.clipRect(0,0,500,500);
         paint(g);
          }

/*
   public void keyDown(int k){
      System.out.print(" You pressed -->[");
      System.out.println(k);
      key = true;
      repaint();
        }
*/
 
    public void mouseDown(int _x, int _y){
           // x = _x;
           // y = _y;

           if( _x > 205 && _x < 230 && _y > 505 && _y < 525)
                event = Up;
          if( _x > 160 && _x < 190 && _y > 555 && _y < 570)
                event = Left;
          if( _x > 255 && _x < 295 && _y > 560 && _y < 575)
                event = Right;
          if( _x > 205 && _x < 250 && _y > 605 && _y < 625)
                event = Down; 

          switch (event){
          case Up    : prevy = y ;y = y - speed; break; 
          case Left  : prevx = x; x = x - speed; break; 
          case Right : prevx = x; x = x + speed; break; 
          case Down  : prevy = y; y = y + speed; break; 
            }

         showStatus("x : " + String.valueOf(_x) + " y : " + String.valueOf(_y) );
         System.out.println("Sending");
         System.out.println(prevx);
         System.out.println(prevy);
         System.out.println(x);
         System.out.println(y);
          Client.DataSendThread( String.valueOf(prevx) + " " + String.valueOf(prevy) + " " +String.valueOf(x) + " " +  String.valueOf(y));
          //  repaint();
          }
 
    public void run(){

            // x = Math.random() * 500; 
            // y = Math.random() * 500; 
            // repaint(); 
        System.out.println("Inside Game Class");
           Client =  new checking(this);
         //     new getInput();
        //   new startMainClient();
        System.out.println("After starting startMainClient");
       }
}

class checking extends Thread{
 PrintStream send ;
 String name,passwd;
 DataReceiveThread recThread;
 Game game;

     public checking(Game _game){
     game = _game;
     System.out.println("Inside Checking");
     this.start();
      }
     public void run(){
      int i,j;

      System.out.println("Inside Checking + RUN ");
       Socket server = new Socket(true);


      for(i=0;i<100;i++)
       for(j=0;j<100;j++);

       System.out.println(" Before connect ");

       boolean portFlag = false;

    try{
       server.connect(new InetAddress("128.230.7.14"),1080);
       }
       catch(net.SocketException e){
         System.out.println(e.getMessage());
         System.out.println("Server may be down. Please try after some time");
       }


       System.out.println(" After connect ");

       DataInputStream receive = new DataInputStream(server.inputStream);
       send = new PrintStream(server.outputStream);

       DataInputStream kb = new DataInputStream(System.in);


        boolean validLogin = false;


       System.out.println(" Before whileLoop ");
       
        validLogin = false;
       while(!validLogin){
       System.out.println("Login: ");
       //name = kb.readLine();

     name = receive.readLine();

      System.out.println("Recived name as [" + name + "]");
       

       System.out.println(name + "`s Password: ");
       //passwd = kb.readLine();
 
       passwd = name;
       

       if(passwd.compareTo(name)!=0)
           {
           System.out.println(" Invalid Password");
           continue ;
           }
     validLogin = true;
     }

       //send.println(name);

    System.out.println( "Before Received ");

     recThread = new DataReceiveThread(receive,game);

      }

 
      public void DataSendThread(String data)
      {
       send.println(data);
       System.out.println("Sending data " +  data);
       }
 



 }
  
class DataReceiveThread extends Thread{
DataInputStream receive;
Game game;



 public DataReceiveThread(DataInputStream _receive,Game _game){
         receive = _receive;
         game = _game;
         this.start();
         }

  public void run(){
       String s;
       int i,j;
       char c[];

         while(true){
            s = receive.readLine();
           System.out.println(s);
          // Extract information 

           c =  s.toCharArray();

          i=j=0;
        while(c[i] != ' ')i = i + 1;
        game.clearx = Integer.valueOf(s.substring(j,i)).intValue(); 
       
         i++; j = i;
        while(c[i] != ' ')i = i + 1;
        game.cleary = Integer.valueOf(s.substring(j,i)).intValue(); 
       
         i++; j = i;
        while(c[i] != ' ')i = i + 1;
        game.x = Integer.valueOf(s.substring(j,i)).intValue(); 

        j= i + 1;         
        game.y = Integer.valueOf(s.substring(j,s.length())).intValue(); 
        System.out.println("Parsed value  "  + String.valueOf(game.clearx) + " " + String.valueOf(game.cleary) + " " + String.valueOf(game.x) + " " + String.valueOf(game.y));
        game.repaint();
               
          }
    }
 }


class sendThread extends Thread{
       Socket newSocket;
       String temp = new String();
       String from = new String();
       int port;
       int i;


       public sendThread(String _from ,int  _port){
       from = _from;
       port = _port;
       System.out.println(" Before starting thread ");
      this.start();
      }


  public void run(){
       int i,j;

       Socket server = new Socket(true);

  for(i=0;i<100;i++)
     for(j=0;j<100;j++);

       server.connect(new InetAddress("128.230.7.14"),port);

       DataInputStream receive = new DataInputStream(server.inputStream);
       PrintStream send = new PrintStream(server.outputStream);

       DataInputStream kb = new DataInputStream(System.in);


      while(true){
       System.out.println("Input data");
       temp = kb.readLine();

       System.out.println( "128.230.7.14:" + Integer.toString(port) + temp);
       send.println(temp);
        if(temp.compareTo("end")==0)
              break;
      }
  }
}

class receiveThread extends Thread{
       Socket newSocket;
       String temp = new String();
       String from = new String();
       int port;
       int portNumber =5000;
       int i;


       public receiveThread(String _from ,int  _port){
       from = _from;
       port = _port;
       System.out.println(" Before starting thread ");
      this.start();
      }


  public void run(){

       Socket server = new Socket(true);



       System.out.println(" Before Binding ");
        server.bindToPort(new InetAddress("128.230.7.14"),port);
       System.out.println("Binding Complete");
        server.listen(5);
       System.out.println("Listen Complete");
        newSocket = server.accept();
       System.out.println("Accept Complete");
       DataInputStream receive = new DataInputStream(newSocket.inputStream);
       PrintStream send = new PrintStream(server.outputStream);



      while(true){
       System.out.println("Waiting for data");
       temp =  receive.readLine();

        if(temp.compareTo("end")==0)
              break;
       System.out.println( "128.230.7.14:" + Integer.toString(port) + temp);
      }

     }
}

