/*  Daniel Wyszynski 
    Center for Applied Large-Scale Computing (CALC) 
    04-12-95 

    Test of text animation.

        Changes by kwalrath@scndprsn.Eng.Sun.COM : Added thread
        suspension.  Click on the text and it will pause.  Thanks
        Kathy.

*/
import awt.Graphics;
import awt.Font;
import awt.Color;
import java.util.Vector;
import browser.Applet;

class ColorItem extends Object  {
        String key;
        Color value;

        ColorItem() {}

        ColorItem(String _key, Color _value)    {
                key = _key;
                value = _value;
                                                }
                                }

class NervousText extends Applet implements Runnable {

	Vector citv = new Vector();
        char separated[];
        String s = null;
        Thread killme = null;
        int i;
        int x_coord = 0, y_coord = 0;
        String num;
        int speed=35;
        int counter =0;
        boolean threadSuspended = false; //added by kwalrath

public void init() {
        resize(1024,100);
	int size;
	String attr = getAttribute("size");
	if(attr != null) { size = (int)Integer.parseInt(attr); }
	else { size = 36; }
	Font f = getFont("Helvetica",Font.BOLD,size);
        font = f;
	s = getAttribute("text");

        citv.addElement(new ColorItem("blue",Color.blue));
	citv.addElement(new ColorItem("white",Color.white));
        citv.addElement(new ColorItem("cyan",Color.cyan));
	citv.addElement(new ColorItem("white",Color.white));
        citv.addElement(new ColorItem("gray",Color.gray));
	citv.addElement(new ColorItem("white",Color.white));
        citv.addElement(new ColorItem("green",Color.green));
	citv.addElement(new ColorItem("white",Color.white));
        citv.addElement(new ColorItem("magenta",Color.magenta));
	citv.addElement(new ColorItem("white",Color.white));
        citv.addElement(new ColorItem("orange",Color.orange));
	citv.addElement(new ColorItem("white",Color.white));
        citv.addElement(new ColorItem("pink",Color.pink));
	citv.addElement(new ColorItem("white",Color.white));
        citv.addElement(new ColorItem("red",Color.red));
	citv.addElement(new ColorItem("white",Color.white));
        citv.addElement(new ColorItem("yellow",Color.yellow));
	citv.addElement(new ColorItem("white",Color.white));
 

        separated =  new char [s.length()];
        s.getChars(0,s.length(),separated,0);
 }

public void start() {
        if(killme == null) 
        {
        killme = new Thread(this);
        killme.start();
        }
 }

public void stop() {
        killme = null;
 }

public void run() {
        while (killme != null) {
        Thread.sleep(100);
        repaint();
        }
        killme = null;
 }

public void paint(Graphics g) {
	int off;
        for(i=0;i<s.length();i++)
        {
        x_coord = (int) (Math.random()*10+15*i);
        y_coord = (int) (Math.random()*10+36);
	off = (int)(Math.random()*citv.size());
	ColorItem cit = (ColorItem)citv.elementAt(off);
	Color col = cit.value;
	g.setForeground(col);
        g.drawChars(separated, i,1,x_coord,y_coord);
        }
 }

/* Added by kwalrath. */
public void mouseDown(int x, int y) {
        if (threadSuspended) {
            killme.resume();
        }
        else {
            killme.suspend();
        }
        threadSuspended = !threadSuspended;
    }
}

