import browser.Applet;
import net.*;
import awt.*;

class TCE extends Applet	{
   boolean fullPaint = true;
   int x, y, xy;
   int dx, dy;
   int prevx,prevy;
   int rx0,ry0,rx1,ry1;
   byte vec[];
   Color pal[] = { Color.red, Color.green, Color.blue, Color.white,
		    Color.black, Color.magenta, Color.cyan, Color.yellow };
   
   public void init()	{
	dx = 8; dy = 8;
        prevx=prevy =0;
	x = 100; y = 50; xy = x*y;
	vec = new byte[xy];
	resize(x*dx,y*dy);
setRandom();
	repaint();
   }

   public void paint(Graphics g) {
	int ix,iy,j;
		for(iy=0; iy <y; iy++)	{
			for(ix=0; ix<x; ix++)	{
				j = iy*x + ix;
				g.setForeground(pal[vec[j]]);
				rx1=ix*dx; ry1=iy*dy;
				g.fillRect(rx1,ry1,dx,dy);
			}
		}
        prevx = x; prevy =y;
   }

   public void update(Graphics g) {
	if(fullPaint == false) {

               if (prevx ==0 && prevy ==0);
               else{
                  int ix,iy,j;
                for(iy=0; iy <prevy; iy++)  {
                        for(ix=0; ix<prevx; ix++)   {
                                rx1=ix*dx; ry1=iy*dy;
                                g.clearRect(rx1,ry1,dx,dy);
                        }
                }
               }
		g.clipRect(rx0,ry0,dx,dy);
	}
	paint(g);
   }

   protected void start() {
	fullPaint = false;
	int n = x*y;
	while(n-- > 0) {
		randomUpdate();
		repaint();
	}
   }

   protected void stop() {
   }

   public void setRandom() {
        int i;
        for(i=0; i<xy; i++)     {
                vec[i] = (byte)(8*Math.random());
        }
   }

   public void randomUpdate() {
	int ix = (int)(x*Math.random());
	int iy = (int)(y*Math.random());
	rx0 = ix*dx; ry0 = iy*dy;
	int j = iy*x + ix;
	vec[j] = 1;
   }
}
